<div fxLayout="column" style="z-index: 1!important;">
  <div fxLayout="row" [style.height.px]="internalHeight" style="overflow-y: auto; padding: 5px;">
    <dx-data-grid
      #table
      [dataSource]="data"
      [noDataText]="noDataText"
      (onFocusedRowChanged)="setSelectedRow($event)"
      (contextmenu)="prepareContextMenu($event)"
      style="overflow-x: auto;"
      (onExporting)="onExporting($event)"
      [showBorders]="true"
      [focusedRowEnabled]="true"
      [showColumnLines]="true"
      [showRowLines]="true"
      keyExpr="id"
      (onRowDblClick)="rowDoubleClick($event)"
      [rowAlternationEnabled]="true"
      [allowColumnResizing]="true"
      [columnAutoWidth]="true"
      [allowColumnReordering]="true">
      <dxo-export
        [enabled]="true"
        [formats]="['pdf', 'xlsx', 'docx', 'csv']"
      ></dxo-export>
      <dxo-state-storing
        [enabled]="true"
        type="localStorage"
      >
      </dxo-state-storing>
      <dxo-selection
        *ngIf="hasSelection"
        [selectAllMode]="'allPages'"
        [showCheckBoxesMode]="checkBoxesMode"
        mode="multiple"
      ></dxo-selection>
      <dxo-column-chooser [allowSearch]="true" [enabled]="true"
                          [emptyPanelText]="'Σύρτε μια στήλη εδώ'"
                          [title]="'Απόκρυψη στηλών'"></dxo-column-chooser>
      <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
      <dxo-filter-row
        [visible]="showFilterRow"
        [applyFilter]="currentFilter"
      ></dxo-filter-row>
      <dxo-header-filter [visible]="showHeaderFilter" [title]="'Επιλογή όλων'" [textContent]="'Επιλογή'"
                         [texts]="{cancel: 'άκυρο', emptyValue: 'Επιλογή όλων'}"></dxo-header-filter>
      <dxo-search-panel
        [visible]="true"
        [width]="240"
        placeholder="Αναζήτηση..."
      ></dxo-search-panel>
      <dxo-grouping
        [contextMenuEnabled]="true">
      </dxo-grouping>
      <dxo-group-panel [emptyPanelText]="'Σύρτε μια στήλη εδώ για να την ομαδοποιήσετε'"
                       [visible]="true"></dxo-group-panel>
      <dxi-column *ngFor="let column of renderDateColumns()" [title]="column.label"
                  [autoExpandGroup]="true"
                  [caption]="displayCaption(column.label)" [dataField]="column.key" [alignment]="'left'"
                  [format]="'dd-MM-yyyy HH:mm'" [showWhenGrouped]="true" [dataType]="'date'"
                  [visible]="column.displayOnTable"></dxi-column>

      <dxi-column *ngFor="let column of renderNonDateColumns()" [title]="column.label"
                  [autoExpandGroup]="true"
                  [caption]="displayCaption(column.label)" [dataField]="column.key" [alignment]="getAlignment(column)"
                  [showWhenGrouped]="true" [visible]="column.displayOnTable" [dataType]="column.type"></dxi-column>

      <dxi-column *ngIf="hasActions"
                  [alignment]="'left'"
                  caption="Ενέργειες"
                  [allowFiltering]="false"
                  [allowSorting]="false"
                  [allowExporting]="false"
                  [allowGrouping]="false"
                  cellTemplate="cellTemplate-report"
      ></dxi-column>
      <dxo-scrolling rowRenderingMode="virtual"> </dxo-scrolling>
      <dxo-paging [pageSize]="25"></dxo-paging>
      <dxo-pager
        [visible]="true"
        [allowedPageSizes]="allowedPageSizes"
        [displayMode]="'full'"
        [showPageSizeSelector]="true"
        [showInfo]="true"
        [showNavigationButtons]="true"
      >
      </dxo-pager>

      <div *dxTemplate="let data of 'cellTemplate-report'" fxLayout="row" fxLayoutGap="1px">
        <button *ngIf="hasThisAction('navigate')" mat-icon-button
                (click)="navigateTo(data)"
                matTooltip="Προεπισκόπηση">
          <mat-icon class="internal-icons">visibility</mat-icon>
        </button>
        <button *ngIf="hasThisAction('create')" mat-icon-button
                (click)="create(data)"
                matTooltip="Δημιουργία τιμολογίου">
          <mat-icon class="internal-icons">add</mat-icon>
        </button>
        <button *ngIf="hasThisAction('download')" mat-icon-button
                (click)="download(data)"
                matTooltip="Λήψη pdf">
          <mat-icon class="internal-icons">download</mat-icon>
        </button>
      </div>

    </dx-data-grid>
  </div>
</div>
